
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Point_ledger_entriesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const point_ledger_entries = await db.point_ledger_entries.create(
            {
                id: data.id || undefined,
        
        entry_type: data.entry_type
        ||
        null
            ,
            
        points_delta: data.points_delta
        ||
        null
            ,
            
        coins_delta: data.coins_delta
        ||
        null
            ,
            
        reason: data.reason
        ||
        null
            ,
            
        occurred_at: data.occurred_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await point_ledger_entries.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await point_ledger_entries.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return point_ledger_entries;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const point_ledger_entriesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                entry_type: item.entry_type
            ||
            null
            ,
            
                points_delta: item.points_delta
            ||
            null
            ,
            
                coins_delta: item.coins_delta
            ||
            null
            ,
            
                reason: item.reason
            ||
            null
            ,
            
                occurred_at: item.occurred_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const point_ledger_entries = await db.point_ledger_entries.bulkCreate(point_ledger_entriesData, { transaction });

        // For each item created, replace relation files
        

        return point_ledger_entries;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const point_ledger_entries = await db.point_ledger_entries.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.entry_type !== undefined) updatePayload.entry_type = data.entry_type;
        
        
        if (data.points_delta !== undefined) updatePayload.points_delta = data.points_delta;
        
        
        if (data.coins_delta !== undefined) updatePayload.coins_delta = data.coins_delta;
        
        
        if (data.reason !== undefined) updatePayload.reason = data.reason;
        
        
        if (data.occurred_at !== undefined) updatePayload.occurred_at = data.occurred_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await point_ledger_entries.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await point_ledger_entries.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await point_ledger_entries.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return point_ledger_entries;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const point_ledger_entries = await db.point_ledger_entries.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of point_ledger_entries) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of point_ledger_entries) {
                await record.destroy({transaction});
            }
        });


        return point_ledger_entries;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const point_ledger_entries = await db.point_ledger_entries.findByPk(id, options);

        await point_ledger_entries.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await point_ledger_entries.destroy({
            transaction
        });

        return point_ledger_entries;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const point_ledger_entries = await db.point_ledger_entries.findOne(
            { where },
            { transaction },
        );

        if (!point_ledger_entries) {
            return point_ledger_entries;
        }

        const output = point_ledger_entries.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await point_ledger_entries.getOrganization({
            transaction
        });
        
        
        output.user = await point_ledger_entries.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.reason) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'point_ledger_entries',
                        'reason',
                        filter.reason,
                    ),
                };
            }
            

            
            

            
            if (filter.points_deltaRange) {
                const [start, end] = filter.points_deltaRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    points_delta: {
                    ...where.points_delta,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    points_delta: {
                    ...where.points_delta,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.coins_deltaRange) {
                const [start, end] = filter.coins_deltaRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    coins_delta: {
                    ...where.coins_delta,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    coins_delta: {
                    ...where.coins_delta,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.occurred_atRange) {
                const [start, end] = filter.occurred_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    occurred_at: {
                    ...where.occurred_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    occurred_at: {
                    ...where.occurred_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.entry_type) {
                where = {
                    ...where,
                entry_type: filter.entry_type,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.point_ledger_entries.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'point_ledger_entries',
                        'reason',
                        query,
                    ),
                ],
            };
        }

        const records = await db.point_ledger_entries.findAll({
            attributes: [ 'id', 'reason' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['reason', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.reason,
        }));
    }

    
};

